import java.util.*;

/**
 * La classe LabClass reprsente une liste d'inscriptions pour une sance de TP. Elle contient
 * l'heure, la salle et les participants, ainsi que le nom de l'enseignant.
 * 
 * @author Michael Kolling et David Barnes
 * @version 2001.05.24
 */
public class LabClass
{
    private String instructor;
    private String room;
    private String timeAndDay;
    private List students;
    private int capacity;
    
    /**
     * Cre un LabClass avec un nombre maximum d'inscriptions. Tous les autres dtails
     * sont dfinis sur les valeurs par dfaut.
     */
    public LabClass(int maxNumberOfStudents)
    {
        instructor = "unknown";
        room = "unknown";
        timeAndDay = "unknown";
        students = new ArrayList();
        capacity = maxNumberOfStudents;
    }

    /**
     * Ajoute un tudiant  cette LabClass.
     */
    public void enrollStudent(Student newStudent)
    {
        if(students.size() == capacity) {
            System.out.println("La classe est pleine, vous ne pouvez plus vous inscrire.");
        }
        else {
            students.add(newStudent);
        }
    }
    
    /**
     * Renvoie le nombre d'tudiants actuellement inscrits dans cette LabClass.
     */
    public int numberOfStudents()
    {
        return students.size();
    }
    
    /**
     * Dfinit le numro de salle pour cette LabClass.
     */
    public void setRoom(String roomNumber)
    {
        room = roomNumber;
    }
    
    /**
     * Dfinit l'heure de cette LabClass. Le paramtre doit dfinir le jour
     * et l'heure, comme "vendredi, 10h00".
     */
    public void setTime(String timeAndDayString)
    {
        timeAndDay = timeAndDayString;
    }
    
    /**
     * Dfinit le nom de l'instructeur pour cette LabClass.
     */
    public void setInstructor(String instructorName)
    {
        instructor = instructorName;
    }
    
    /**
     * Affiche une liste de la classe avec d'autres infos sur LabClass sur le
     * terminal standard.
     */
    public void printList()
    {
        System.out.println("Lab class " + timeAndDay);
        System.out.println("Instructor: " + instructor + "   room: " + room);
        System.out.println("Class list:");
        Iterator i = students.iterator();
        while(i.hasNext()) {
            Student student = (Student)i.next();
            student.print();
        }
        System.out.println("Number of students: " + numberOfStudents());
    }
}
