
/**
 * La classe Student reprsente un tudiant d'une classe de Travaux Pratiques.
 * Elle contient des informations sur les tudiants.
 * 
 * @author Michael Kolling et David Barnes
 * @version 2001.05.24
 */
public class Student
{
    // nom complet de l'tudiant
    private String name;
    // numro d'identit de l'tudiant
    private String id;
    // nombre de crdits obtenus jusqu' prsent
    private int credits;

    /**
     * Cre un nouvel tudiant avec le nom et le numro d'identit donns.
     */
    public Student(String fullName, String studentID)
    {
        name = fullName;
        id = studentID;
        credits = 0;
    }

    /**
     * Renvoie le nom complet de l'tudiant.
     */
    public String getName()
    {
        return name;
    }

    /**
     * Dfinit un nouveau nom pour cet tudiant.
     */
    public void changeName(String replacementName)
    {
        name = replacementName;
    }

    /**
     * Renvoie le numro d'identit de cet tudiant.
     */
    public String getStudentID()
    {
        return id;
    }

    /**
     * Ajoute des crdits  ceux accumuls par l'tudiant.
     */
    public void addCredits(int additionalPoints)
    {
        credits += additionalPoints;
    }

    /**
     * Renvoie le nombre de crdits accumuls par cet tudiant.
     */
    public int getCredits()
    {
        return credits;
    }

    /**
     * Renvoie l'identifiant de cet tudiant. Il s'agit d'une combinaison
     * des quatre premiers caractres de son nom et des trois premiers
     * de son numro d'identit.
     */
    public String getLoginName()
    {
        return name.substring(0,4) + id.substring(0,3);
    }
    
    /**
     * Affiche le nom de l'tudiant et son numro d'identit sur le terminal.
     */
    public void print()
    {
        System.out.println(name + " (" + id + ")");
    }
}
