import java.util.StringTokenizer;

/**
 * TicketMachine modlise une billetterie automatique qui met
 * des billets  prix unique.
 * Le prix d'un billet est spcifi via le constructeur.
 * Les instances vrifieront qu'un utilisateur entre uniquement
 * des sommes logiques et n'affichera le billet
 * que si suffisamment d'argent a t insr.
 * 
 * @author David J. Barnes et Michael Kolling
 * @version 2002.02.06
 */
public class TicketMachine
{
	// Le prix d'un billet de cette machine.
	private int price;
	// La somme d'argent entre par un client jusqu' maintenant.
	private int balance;
	// La somme totale collecte par cette machine.
	private int total;
	
	/**
	 * Cre une machine qui dlivre des billets du prix donn.
	 */
	public TicketMachine(int ticketCost)
	{
		price = ticketCost;
		balance = 0;
		total = 0;
	}
	
	/**
	 * @Return Le prix d'un billet.
	 */
	public int getPrice()
	{
		return price;
	}
	
	/**
	 * Return La somme d'argent dj insre pour le prochain
	 * billet.
	 */
	public int getBalance()
	{
		return balance;
	}
	
	/**
	 * Reoit une somme en centimes de la part d'un client.
	 * Vrifie que la somme est logique.
	 */
	public void insertMoney(int amount)
	{
		if(amount > 0) {
			balance += amount;
		}
		else {
			System.out.println("Utilisez une somme positive : " +
					amount);
		}
	}
	
	/**
	 * Affiche un billet si suffisamment d'argent a t insr
	 * et rduit le solde courant du prix du billet. Affiche
	 * un message d'erreur s'il faut rajouter de l'argent.
	 */
	public void printTicket()
	{
		if(balance >= price) {
			// Simule l'affichage d'un billet.
			System.out.println("##################");
			System.out.println("# La ligne BlueJ");
			System.out.println("# Billet");
			System.out.println("# " + price + " centimes.");
			System.out.println("##################");
			System.out.println();
			
			// Actualise le total collect avec le prix.
			total += price;
			// Rduit le solde du prix.
			balance -= price;
		}
		else {
			System.out.println("Vous devez insrer au moins : " +
					(price - balance) + " centimes supplmentaires.");
			
		}
	}
	
	/**
	 * Renvoie l'argent du solde.
	 * Le solde est effac.
	 */
	int refundBalance()
	{
		int amountToRefund;
		amountToRefund = balance;
		balance = 0;
		return amountToRefund;
	}
	
	public int getTotal() {
		return total;
	}
	/** Exemple d'entre: 
	 * billet 1000 entrer 300 
	 * entrer 800 ticket rembourser */
	public static void main(String[] args) {
		TicketMachine tm = null;
		int position = 0;
		while(true) {
			if ( position == args.length )
				break;
			
			String commande = args[position];
			position++;
			if ( commande.substring(0,1).equals("b") ) {
				commande = args[position];
				position++;
				int prix = Integer.parseInt(commande);
				tm = new TicketMachine(prix);
			} else if ( commande.substring(0,1).equals("e") ) {
				commande = args[position];
				position++;
				int prix = Integer.parseInt(commande);
				tm.insertMoney(prix);
				System.out.println("Insr :" + prix );
			} else if ( commande.substring(0,1).equals("t") ) {
				tm.printTicket();
			} else if ( commande.substring(0,1).equals("r") ) {
				System.out.println("Remboursement:" +
						tm.refundBalance() );
			}
			
		}
	}
}
