/**
 * TicketMachine modlise une machine simplifie qui dlivre
 * des billets  prix unique.
 * Le prix d'un billet est spcifi par le biais du constructeur.
 * Cette billetterie est simplifie au sens o elle fait confiance  l'utilisateur
 * pour qu'il insre suffisamment d'argent avant d'imprimer un billet.
 * Elle suppose aussi que les utilisateurs entrent des sommes cohrentes.
 *
 * @author David J. Barnes et Michael Kolling
 * @version 2002.02.06
 */
public class TicketMachine
{
    // Le prix d'un billet de cette machine.
    private int price;
    // La somme insre par un client jusqu' prsent.
    private int balance;
    // Le total collect par cette billetterie.
    private int total;

    /**
     * Cre une billetterie qui dlivre des billets du prix donn.
     * Remarquez que le prix doit tre suprieur  zro et qu'aucune
     * vrification n'est apporte.
     */
    public TicketMachine(int ticketCost)
    {
        price = ticketCost;
        balance = 0;
        total = 0;
    }

    /**
     * Renvoie le prix d'un billet.
     */
    public int getPrice()
    {
        return price;
    }

    /**
     * Renvoie le montant dj insr pour le 
     * prochain billet.
     */
    public int getBalance()
    {
        return balance;
    }

    /**
     * Reoit une somme en centimes de la part d'un client.
     */
    public void insertMoney(int amount)
    {
        balance += amount;
    }

    /**
     * Imprime un billet.
     * Actualise le total collect et 
     * remet le solde  zro.
     */
    public void printTicket()
    {
        // Simule l'impression d'un billet.
        System.out.println("##################");
        System.out.println("# La ligne BlueJ ");
        System.out.println("# Billet");
        System.out.println("# " + price + " centimes.");
        System.out.println("##################");
        System.out.println();

        // Actualise le total collect avec le solde.
        total += balance;
        // Efface le solde.
        balance = 0;
    }
    
    public static void main(String[] arg){
        new TicketMachine(1000);
    }
}
