
/**
 * La classe ClockDisplay implante l'affichage d'une horloge digitale pour
 * une horloge de style europen, de 24 heures. L'horloge affiche les heures et les minutes. 
 * La plage va de 00:00 (minuit)  23:59 (une minute avant 
 * minuit).
 * 
 * L'affichage de l'horloge reoit des "tics" (via la mthode timeTick) chaque minute
 * et ragit en incrmentant l'affichage. Cela fonctionne comme dans une horloge
 * normale : l'heure augmente lorsque les minutes reviennent  zro.
 * 
 * @author Michael Kolling et David J. Barnes
 * @version 2001.05.26
 */
public class ClockDisplay
{
    private NumberDisplay hours;
    private NumberDisplay minutes;
    private String displayString;    // simule l'affichage rel
    
    /**
     * Constructeur des objets ClockDisplay. Ce constructeur 
     * cre une nouvelle horloge  00:00.
     */
    public ClockDisplay()
    {
        hours = new NumberDisplay(24);
        minutes = new NumberDisplay(60);
        updateDisplay();
    }

    /**
     * Constructeur des objets ClockDisplay. Ce constructeur
     * cre un nouveau jeu d'horloge  l'heure spcifie par les 
     * paramtres.
     */
    public ClockDisplay(int hour, int minute)
    {
        hours = new NumberDisplay(24);
        minutes = new NumberDisplay(60);
        setTime(hour, minute);
    }

    /**
     * Cette mthode doit tre appele une fois toutes les minutes - elle fait
     * avancer l'affichage de l'horloge d'une minute.
     */
    public void timeTick()
    {
        minutes.increment();
        if(minutes.getValue() == 0) {  // vient de revenir  zro !
            hours.increment();
        }
        updateDisplay();
    }

    /**
     * Dfinit l'heure d'affichage sur l'heure et la minute
     * spcifies.
     */
    public void setTime(int hour, int minute)
    {
        hours.setValue(hour);
        minutes.setValue(minute);
        updateDisplay();
    }

    /**
     * Renvoie l'heure actuelle de cet affichage au format HH:MM.
     */
    public String getTime()
    {
        return displayString;
    }
    
    /**
     * Met  jour la chane interne qui sert  l'affichage.
     */
    private void updateDisplay()
    {
        displayString = hours.getDisplayValue() + ":" + 
                        minutes.getDisplayValue();
    }
}
