
/**
 * La classe NumberDisplay reprsente un affichage digital qui peut contenir
 * des valeurs allant de zro  une limite donne. La limite peut tre spcifie  la cration
 * de l'affichage. Les valeurs vont de zro (inclus)  limite-1. Si elles sont utilises,
 * par exemple pour les secondes sur une horloge digitale, la limite serait 60, 
 * entranant des valeurs d'affichage de 0  59. A l'incrmentation, l'affichage 
 * revient automatiquement  zro lorsqu'il atteint la limite.
 * 
 * @author Michael Kolling et David J. Barnes
 * @version 2001.05.26
 */
public class NumberDisplay
{
    private int limit;
    private int value;

    /**
     * Constructeur des objets de la classe Display
     */
    public NumberDisplay(int rollOverLimit)
    {
        limit = rollOverLimit;
        value = 0;
    }

    /**
     * Renvoie la valeur actuelle.
     */
    public int getValue()
    {
        return value;
    }

    /**
     * Renvoie la valeur d'affichage (c'est--dire la valeur actuelle sous forme de chane
     *  deux chiffres. Si la valeur est infrieure  dix, un zro sera ajout
     * avant).
     */
    public String getDisplayValue()
    {
        if(value < 10)
            return "0" + value;
        else
            return "" + value;
    }

    /**
     * Dfinit la valeur d'affichage sur la nouvelle valeur. Si la nouvelle
     * valeur est infrieure  zro ; au-dessus de la limite, ne fait rien.
     */
    public void setValue(int replacementValue)
    {
        if((replacementValue >= 0) && (replacementValue < limit))
            value = replacementValue;
    }

    /**
     * Incrmente la valeur d'affichage de un, en revenant  zro si la
     * limite est atteinte.
     */
    public void increment()
    {
        value = (value + 1) % limit;
    }
}
