/**
 * Une classe permettant de modliser un simple client de messagerie. Il est excut par un
 * utilisateur particulier et envoie et rcupre du courrier via un serveur particulier.
 * @author David J. Barnes et Michael Kolling
 * @version 2001.05.30
 */
public class MailClient
{
    // Le serveur utilis pour l'envoi et la rcetion.
    private MailServer server;
    // L'utilisateur excutant ce client.
    private String user;

    /**
     * Cre un client de messagerie excut par l'utilisateur et attach  un serveur donn.
     */
    public MailClient(MailServer server, String user)
    {
        this.server = server;
        this.user = user;
    }

    /**
     * Renvoie le prochain courrier (s'il y en a) pour cet utilisateur.
     */
    public MailItem getNextMailItem()
    {
        return server.getNextMailItem(user);
    }

    /**
     * Affiche le prochain courrier (s'il y en a) pour cet utilisateur sur le 
     * terminal de texte.
     */
    public void printNextMailItem()
    {
        MailItem item = server.getNextMailItem(user);
        if(item == null) {
            System.out.println("Pas de nouveau courrier.");
        }
        else {
            item.print();
        }
    }

    /**
     * Envoie le message donn au destinataire donn via
     * le serveur de messagerie attach.
     * @param to Le destinataire souhait.
     * @param mess Un message prt  tre envoy.
     */
    public void sendMessage(String to, String message)
    {
        MailItem mess = new MailItem(user, to, message);
        server.post(mess);
    }
}
