/**
 * Une classe pour modliser un simple lment de courrier. Il a les adresses
 * de l'expditeur et du destinataire et une chane de message.
 * @author David J. Barnes et Michael Kolling
 * @version 2001.05.30
 */
public class MailItem
{
    // L'metteur de l'lment.
    private String from;
    // Le destinataire souhait.
    private String to;
    // Le texte du message.
    private String message;

    /**
     * Cre un courrier de l'expditeur au destinataire donn,
     * contenant le message donn.
     * @param from L'expditeur de cet lment.
     * @param to L'expditeur souhait de cet lment.
     * @param message Le texte du message  envoyer.
     */
    public MailItem(String from, String to, String message)
    {
        this.from = from;
        this.to = to;
        this.message = message;
    }

    /**
     * Renvoie l'expditeur de ce message.
     */
    public String getFrom()
    {
        return from;
    }

    /**
     * Renvoie le destinataire souhait de ce message.
     */
    public String getTo()
    {
        return to;
    }

    /**
     * Renvoie le texte du message.
     */
    public String getMessage()
    {
        return message;
    }

    /**
     * Affiche ce message sur le terminal de texte.
     */
    public void print()
    {
        System.out.println("De : " + from);
        System.out.println("A : " + to);
        System.out.println("Message : " + message);
    }
}
