import java.util.ArrayList;
import java.util.Iterator;

/**
 * Un modle simple de serveur de courrier. Le serveur peut recevoir des
 * messages pour stockage et les livrer aux clients  la demande.
 * @author David J. Barnes et Michael Kolling
 * @version 2001.05.30
 */
public class MailServer
{
    // Stockage de la quantit arbitraire de messages  stocker
    // sur le serveur.
    private ArrayList messages;

    /**
     * Construit un serveur de courrier.
     */
    public MailServer()
    {
        messages = new ArrayList();
    }

    /**
     * @return Le nombre de messages en attente pour l'utilisateur donn.
     * @param who L'utilisateur  vrifier.
     */
    public int howManyMessages(String who)
    {
        int count = 0;
        Iterator it = messages.iterator();
        while(it.hasNext()) {
            MailItem mess = (MailItem) it.next();
            if(mess.getTo().equals(who)) {
                count++;
            }
        }
        return count;
    }

    /**
     * Renvoie le message suivant pour who. Renvoie null s'il n'y en
     * a pas.
     * @param who L'utilisateur demandant le message suivant.
     */
    public MailItem getNextMailItem(String who)
    {
        Iterator it = messages.iterator();
        while(it.hasNext()) {
            MailItem mess = (MailItem) it.next();
             String to = mess.getTo();
             if( to  . equals(who)) {
                it.remove();
                return mess;
             }
        }
        return null;
    }

    /**
     * Ajoute le message donn  la liste de messages.
     * @param item L'lment de courrier  stocker sur le serveur.
     */
    public void post(MailItem item)
    {
        messages.add(item);
    }
}
