/**
 * Une classe qui modlise une vente aux enchres. L'offre contient une rfrence
 * au Lot et  l'utilisateur qui ralise l'offre.
 * @author David J. Barnes et Michael Kolling.
 * @version 2001.05.31
 */
public class Bid
{
    // L'utilisateur qui ralise l'offre.
    private final Person bidder;
    // La valeur de l'offre. Le nombre pourrait tre lev,
    // on utilise donc le type long.
    private final long value;

    /**
     * Cre une offre.
     * @param bidder L'enchrisseur pour le lot.
     * @param value La valeur de l'offre.
     */
    public Bid(Person bidder, long value)
    {
        this.bidder = bidder;
        this.value = value;
    }

    /**
     * @return L'enchrisseur.
     */
    public Person getBidder()
    {
        return bidder;
    }

    /**
     * @return La valeur de l'offre.
     */
    public long getValue()
    {
        return value;
    }
}
