import java.util.ArrayList;

/**
 * Une classe pour conserver une liste de notes de longueur arbitraire.
 * Les notes sont numrotes pour une rfrence externe par un utilisateur humain.
 * Dans cette version, les numros de notes commencent  0.
 * @author David J. Barnes et Michael Kolling.
 * @version 2001.06.08
 */
public class Notebook
{
    // Stockage pour une quantit arbitraire de notes.
    private ArrayList notes;

    /**
     * Ralise toute initialisation exige pour
     * l'agenda.
     */
    public Notebook()
    {
        notes = new ArrayList();
    }

    /**
     * Mmorise une nouvelle note dans l'agenda.
     * @param note La note  mmoriser.
     */
    public void storeNote(String note)
    {
        notes.add(note);
    }

    /**
     * @return Le nombre de notes actuellement dans l'agenda.
     */
    public int numberOfNotes()
    {
        return notes.size();
    }

    /**
     * Prsente une note.
     * @param noteNumber Le numro de la note  afficher.
     */
    public void showNote(int noteNumber)
    {
        if(noteNumber < 0) {
            // Ce n'est pas un numro de note valide, ne rien faire.
        }
        else if(noteNumber < numberOfNotes()) {
            // C'est un numro de note valide, nous pouvons l'afficher.
            System.out.println(notes.get(noteNumber));
        }
        else {
            // Ce n'est pas un numro de note valide, ne rien faire.
        }
    }
}
