/**
 * Lit les donnes du serveur Web et analyse
 * les motifs d'accs horaires.
 * 
 * @author David J. Barnes et Michael Kolling.
 * @version 2001.12.31
 */
public class LogAnalyzer
{
    // Tableau pour stocker les comptes d'accs horaires.
    private int[] hourCounts;
    // Utilise un LogfileReader pour accder aux donnes.
    private LogfileReader reader;

    /**
     * Cre un objet pour analyser les accs Web chaque heure.
     */
    public LogAnalyzer()
    { 
        // Cre l'objet tableau pour contenir les comptes
        // d'accs horaire.
        hourCounts = new int[24];
        // Cre le lecteur pour obtenir les donnes.
        reader = new LogfileReader();
    }

    /**
     * Analyse les donnes d'accs horaire depuis le fichier journal.
     */
    public void analyzeHourlyData()
    {
        while(reader.hasMoreEntries()) {
            LogEntry entry = reader.nextEntry();
            int hour = entry.getHour();
            hourCounts[hour]++;
        }
    }

    /**
     * Affiche les comptes horaire.
     * Ils doivent avoir t dfinis avec un appel pralable
     *  analyzeHourlyData.
     */
    public void printHourlyCounts()
    {
        System.out.println("Hr : Compte");
        for(int hour = 0; hour < hourCounts.length; hour++) {
            System.out.println(hour + ": " + hourCounts[hour]);
        }
    }
    
    /**
     * Affiche les lignes de donnes lues par le LogfileReader
     */
    public void printData()
    {
        reader.printData();
    }
}
