import java.util.StringTokenizer;

/**
 * Dcompose la ligne du fichier journal du serveur Web en
 * champs spars.
 * Actuellement, le fichier journal est suppos contenir
 * des informations de date et d'heure (entiers).
 * 
 * @author David J. Barnes et Michael Kolling.
 * @version 2001.12.31
 */
public class LoglineTokenizer
{
    /**
     * Construit un LogLineAnalyzer
     */
    public LoglineTokenizer()
    {
    }

    /**
     * Cre des mots-cl d'une ligne de journal. Place ses valeurs entires 
     * dans un tableau. La longueur du tableau doit concorder
     * avec le nombre de jetons de la ligne.
     *
     * @param logline La ligne  sparer en mots-cl.
     * @param dataLine L'endroit o stocker les valeurs.
     */
    public void tokenize(String logline, int[] dataLine)
    {
        StringTokenizer tokens = new StringTokenizer(logline);
        if(tokens.countTokens() == dataLine.length) {
            String number = "";
            try{
                StringTokenizer tokenizer = new StringTokenizer(logline);
                int numTokens = tokenizer.countTokens();
                for(int i = 0; i < numTokens; i++) {
                    number = tokenizer.nextToken();
                    dataLine[i] = Integer.parseInt(number);
                }
            }
            catch(NumberFormatException e) {
                System.out.println("Nombre mal format : " + number);
                System.out.println("A la ligne : " + logline);
            }
        }
        else {
            System.out.println("Ligne de journal non valide : " + logline);
        }
    }
}
