import java.awt.*;
import java.awt.geom.*;

/**
 * Classe BallDemo : fournit deux courtes dmonstrations montrant l'utilisation 
 * de la classe Canvas. 
 *
 * @author Michael Kolling et David J. Barnes
 * @version 1.0 (23-Jan-2002)
 */

public class BallDemo   
{
    private Canvas myCanvas;

    /**
     * Cre un objet BallDemo. Cre un nouveau fond et l'affiche.
     */
    public BallDemo()
    {
        myCanvas = new Canvas("Dmo de Ball", 600, 500);
        myCanvas.setVisible(true);
    }
 
    /**
     * Cette mthode montre certaines des oprations de dessin
     * disponibles sur un objet Canvas.
     */
    public void drawDemo()
    {
        myCanvas.setFont(new Font("helvetica", Font.BOLD, 14));
        myCanvas.setForegroundColor(Color.red);

        myCanvas.drawString("Nous pouvons dessiner du texte, ...", 20, 30);
        myCanvas.wait(1000);

        myCanvas.setForegroundColor(Color.black);
        myCanvas.drawString("...dessiner des traits...", 60, 60);
        myCanvas.wait(500);
        myCanvas.setForegroundColor(Color.gray);
        myCanvas.drawLine(200, 20, 300, 50);
        myCanvas.wait(500);
        myCanvas.setForegroundColor(Color.blue);
        myCanvas.drawLine(220, 100, 370, 40);
        myCanvas.wait(500);
        myCanvas.setForegroundColor(Color.green);
        myCanvas.drawLine(290, 10, 320, 120);
        myCanvas.wait(1000);

        myCanvas.setForegroundColor(Color.gray);
        myCanvas.drawString("...et des formes !", 110, 90);

        myCanvas.setForegroundColor(Color.red);

        // la forme  dessiner et dplacer
        int xPos = 10;
        Rectangle rect = new Rectangle(xPos, 150, 30, 20);

        // dplace le rectangle  l'cran
        for(int i = 0; i < 200; i ++) {
            myCanvas.fill(rect);
            myCanvas.wait(10);
            myCanvas.erase(rect);
            xPos++;
            rect.setLocation(xPos, 150);
        }
        //  la fin du dplacement, redessine l'objet afin qu'il reste visible
        myCanvas.fill(rect);
    }

    /**
     * Simule deux balles rebondissantes
     */
    public void bounce()
    {
        int ground = 400;   // position de la ligne de base

        myCanvas.setVisible(true);

        // dessine le sol
        myCanvas.drawLine(50, ground, 550, ground);

        // cre et affiche les balles
        BouncingBall ball = new BouncingBall(50, 50, 16, Color.blue, ground, myCanvas);
        ball.draw();
        BouncingBall ball2 = new BouncingBall(70, 80, 20, Color.red, ground, myCanvas);
        ball2.draw();

        // les fait rebondir
        boolean finished =  false;
        while(!finished) {
            myCanvas.wait(50);           // petit dlai
            ball.move();
            ball2.move();
            // s'arrte lorsque la balle a voyag pendant une certaine distance sur l'axe des x
            if(ball.getXPosition() >= 550 && ball2.getXPosition() >= 550)
                finished = true;
        }
        ball.erase();
        ball2.erase();
    }
}
