import java.util.HashSet;

/**
 * Cette classe implante un systme d'assistance technique. Il s'agit de la classe de haut niveau 
 * de ce projet. Le systme d'assistance communique via la saisie/le renvoi de texte dans le terminal.
 * 
 * Cette classe utilise un objet de la classe InputReader pour lire la saisie de l'utilisateur et 
 * un objet de la classe Responder pour gnrer les rponses. Elle contient une boucle qui lit  plusieurs reprises
 * la saisie et gnre du texte jusqu' ce que l'utilisateur souhaite arrter.
 * 
 * @version    1.0  (31.Oct.2001)
 * @author     Michael Kolling et David J. Barnes
 */
public class SupportSystem
{
    private InputReader reader;
    private Responder responder;
    
    /**
     * Cre un systme d'assistance technique.
     */
    public SupportSystem()
    {
        reader = new InputReader();
        responder = new Responder();
    }

    /**
     * Lance le systme d'assistance technique. Ceci affiche un message de bienvenue et
     * entame un dialogue avec l'utilisateur, jusqu' ce qu'il y mette fin.
     */
    public void start()
    {
        boolean finished = false;

        printWelcome();

        while(!finished) {
            HashSet input = reader.getInput();

            if(input.contains("bye")) {
                finished = true;
            }
            else {
                String response = responder.generateResponse(input);
                System.out.println(response);
            }
        }
        printGoodbye();
    }

    /**
     * Affiche un message de bienvenue  l'cran.
     */
    private void printWelcome()
    {
        System.out.println("Bienvenue dans le systme d'assistance technique DodgySoft.");
        System.out.println();
        System.out.println("Veuillez nous indiquer votre problme.");
        System.out.println("Nous vous aiderons  le rsoudre.");
        System.out.println("Tapez 'bye' pour quitter le systme.");
    }

    /**
     * Affiche un message d'au revoir  l'cran.
     */
    private void printGoodbye()
    {
        System.out.println("Merci pour votre visite. Bye...");
    }
}
