import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * La classe InputReader lit le texte saisi dans la fentre du terminal. Le texte
 * tap par l'utilisateur est divis en mots, et un ensemble de mots est fourni.
 * 
 * @author     Michael Kolling et David J. Barnes
 * @version    1.0  (31.Oct.2001)
 */
public class InputReader
{
    private BufferedReader reader;

    /**
     * Cre un nouveau InputReader qui lit le texte du terminal.
     */
    public InputReader()
    {
        reader = new BufferedReader(new InputStreamReader(System.in));;
    }

    /**
     * Lit une ligne de texte de saisie standard (le terminal), puis la renvoie
     * sous forme d'ensemble de mots.
     *
     * @return  Un ensemble de chanes, chacune tant un des mots taps par l'utilisateur
     */
    public String getInput() 
    {
        System.out.print("> ");                // affiche le prompt
        String inputLine = readInputLine();

        return inputLine;
    }

    /**
     * Lit une ligne saisie et la renvoie sous forme de chane. 
     *
     * @return  Une chane reprsentant la saisie, ou toute chane vide en cas d'erreur.
     */
    private String readInputLine()
    {
        String line = "";

        try {
            line = reader.readLine();
        }
        catch(java.io.IOException exc) {
            System.out.println ("Erreur au cours de la lecture : " + exc.getMessage());
        }
        return line;
    }
}
