/**
 * Cette classe implante un systme d'assistance technique. C'est la classe
 * de haut niveau de ce projet. Le systme d'assistance communique via
 * les saisies/rponses de texte sur le terminal.
 * 
 * Cette classe utilise un objet de classe InputReader pour lire une saisie de
 * l'utilisateur et un objet de classe Responder pour gnrer des rponses.
 * Elle contient une boucle qui lit les saisies  plusieurs reprises et gnre une
 * rponse jusqu' ce que l'utilisateur veuille partir.
 * 
 * @author     Michael Kolling et David J. Barnes
 * @version    0.1 (1.fv.2002)
 */
public class SupportSystem
{
    private InputReader reader;
    private Responder responder;
    
    /**
     * Cre un systme d'assistance technique.
     */
    public SupportSystem()
    {
        reader = new InputReader();
        responder = new Responder();
    }

    /**
     * Dmarre le systme d'assistance technique. Affiche un message
     * de bienvenue et entame un dialogue avec l'utilisateur, jusqu' ce que 
     * celui-ci y mette fin.
     */
    public void start()
    {
        boolean finished = false;

        printWelcome();

        while(!finished) {
            String input = reader.getInput();

            if(input.startsWith("bye")) {
                finished = true;
            }
            else {
                String response = responder.generateResponse();
                System.out.println(response);
            }
        }
        printGoodbye();
    }

    /**
     * Affiche un message de bienvenue  l'cran.
     */
    private void printWelcome()
    {
        System.out.println("Bienvenue dans le systme d'assistance technique DodgySoft.");
        System.out.println();
        System.out.println("Veuillez nous indiquer votre problme.");
        System.out.println("Nous vous aiderons  le rsoudre.");
        System.out.println("Tapez 'bye' pour quitter le systme.");
    }

    /**
     * Affiche un message d'au revoir  l'cran.
     */
    private void printGoodbye()
    {
        System.out.println("Nous avons t heureux de vous aider. Bye...");
    }
}
