import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * La classe InputReader lit le texte saisi dans le terminal de texte standard. Le texte
 * tap par un utilisateur est alors dcoup en mots et un ensemble de mots est fourni.
 * 
 * @author     Michael Kolling et David J. Barnes
 * @version    0.1  (1.Feb.2002)
 */
public class InputReader
{
    private BufferedReader reader;

    /**
     * Cre un nouvel InputReader qui lit du texte  partir du terminal.
     */
    public InputReader()
    {
        reader = new BufferedReader(new InputStreamReader(System.in));;
    }

    /**
     * Lit une ligne de texte  partir de la saisie standard (le terminal) et
     * la renvoie sous la forme d'un ensemble de mots.
     *
     * @return  Un ensemble de String, o chacun est l'un des mots
     *          tap par l'utilisateur
     */
    public String getInput() 
    {
        System.out.print("> ");                // affiche l'invite
        String inputLine = readInputLine();

        return inputLine;
    }

    /**
     * Lit une ligne de saisie et la renvoie sous forme de String. 
     *
     * @return  Un String reprsentant la saisie ou un String vide en cas d'erreur.
     */
    private String readInputLine()
    {
        String line = "";

        try {
            line = reader.readLine();
        }
        catch(java.io.IOException exc) {
            System.out.println ("Erreur au cours de la lecture : " + exc.getMessage());
        }
        return line;
    }
}
