import java.util.ArrayList;
import java.util.Random;

/**
 * La classe responder reprsente un objet gnrateur de rponses. Elle
 * permet de gnrer une rponse automatique.
 * Ceci est la deuxime version de cette classe. Cette fois-ci, nous gnrons 
 * un comportement alatoire en slectionnant une phrase au hasard parmi une
 * liste prdfinie de rponses.
 * 
 * @author     Michael Kolling et David J. Barnes
 * @version    0.2  (2.fv.2002)
 */
public class Responder
{
    private Random randomGenerator;
    private ArrayList responses;

    /**
     * Construit un Responder
     */
    public Responder()
    {
        randomGenerator = new Random();
        responses = new ArrayList();
        fillResponses();
    }

    /**
     * Gnre une rponse.
     * 
     * @return  Une chane  afficher en rponse
     */
    public String generateResponse()
    {
        // Choisit un nombre d'index au hasard dans la liste de rponses 
        // par dfaut. Le nombre sera compris entre 0 (inclus) et la taille
        // de la liste (exclue).
        int index = randomGenerator.nextInt(responses.size());
        return (String) responses.get(index);
    }

    /**
     * Construit une liste de rponses par dfaut parmi lesquelles choisir
     * si nous ne savons pas quoi dire.
     */
    private void fillResponses()
    {
        responses.add("Cela semble trange. Pourriez-vous dcrire le problme plus prcisment ?");
        responses.add("Aucun autre client ne s'est jamais plaint de ceci. \n" +
                             "Quelle est votre configuration systme ?");
        responses.add("Cela semble intressant. Dites-m'en plus...");
        responses.add("J'ai besoin d'informations supplmentaires  ce sujet.");
        responses.add("Avez-vous vrifi s'il n'y avait pas de conflit de dll ?");
        responses.add("Ceci est expliqu dans le manuel. L'avez-vous lu ?");
        responses.add("Votre description n'est pas claire. Y a-t-il un expert\n" +
                             "avec vous qui pourrait dcrire ceci plus prcisment ?");
        responses.add("Ceci n'est pas un bogue, c'est une fonction !");
        responses.add("Pourriez-vous prciser ?");
    }
}
