/**
 * Cette classe implante un systme de support technique. C'est la classe
 * de haut niveau de ce projet. Le systme communique via
 * la saisie/l'affichage de texte dans le terminal.
 * 
 * Cette classe utilise un objet de la classe InputReader pour lire la saisie de
 * l'utilisateur et un objet de la classe Responder pour gnrer les rponses. 
 * Elle contient une boucle qui lit  plusieurs reprises l'entre et gnre une rponse
 * jusqu' ce que l'utilisateur souhaite partir.
 * 
 * @author     Michael Kolling et David J. Barnes
 * @version    0.1  (1.Fv.2002)
 */
public class SupportSystem
{
    private InputReader reader;
    private Responder responder;
    
    /**
     * Cre un systme d'assistance technique.
     */
    public SupportSystem()
    {
        reader = new InputReader();
        responder = new Responder();
    }

    /**
     * Dmarre le systme d'assistance technique. Ceci affichera un message de bienvenue et entame
     * un dialogue avec l'utilisateur, jusqu' ce que ce dernier y mette fin.
     */
    public void start()
    {
        boolean finished = false;

        printWelcome();

        while(!finished) {
            String input = reader.getInput().trim().toLowerCase();

            if(input.startsWith("bye")) {
                finished = true;
            }
            else {
                String response = responder.generateResponse();
                System.out.println(response);
            }
        }
        printGoodbye();
    }

    /**
     * Affiche un message de bienvenue  l'cran.
     */
    private void printWelcome()
    {
        System.out.println("Bienvenue dans le systme d'assistance technique DodgySoft.");
        System.out.println();
        System.out.println("Veuillez nous indiquer votre problme. Nous vous aiderons  le rsoudre");
        System.out.println("Tapez 'bye'");
        System.out.println("pour quitter le systme.");
    }

    /**
     * Affiche un message d'au revoir  l'cran.
     */
    private void printGoodbye()
    {
        System.out.println("Nous avons t heureux de vous aider. Bye...");
    }
}
