/**
 * Class Brick - modlise une brique lmentaire.
 * 
 * @author: Michael Kolling
 * @version: 2002.02.08
 */
public class Brick
{
    // Constante.
    private static final int WEIGHT_PER_CM3 = 2;  // poids par cm3 en grammes

    // variables d'instance :
    private int height;
    private int width;
    private int depth;

    /**
     * Cration d'une brique. Les paramtres sont les longueurs des artes en centimtres.
     */
    public Brick(int height, int width, int depth)
    {
        this.height = height;
        this.width = width;
        this.depth = depth;
    }

    /**
     * Renvoie la surface d'une brique en cm2.
     */
    public double getSurfaceArea()
    {
        double side1 = width * height;
        double side2 = width * depth;
        double side3 = depth * height;
        double total = (side1 + side1 + side3) * 2;

        return total;
    }

    /**
     * Renvoie le poids de cette brique en kg.
     */
    public double getWeight()
    {
        return (getVolume() * WEIGHT_PER_CM3) / 1000;
    }

    /**
     * Renvoie le volume de cette brique en cm3.
     */
    public int getVolume()
    {
        return width * height * depth;
    }

    public double getHeight()
    {
        return height;
    }
}
