
/**
 * Une palette est une pile de briques on sur une structure en bois.
 *
 * @author: Michael Kolling
 * @version: 2002.02.08
 */
public class Palette
{
    // constantes :
    private static final double baseWeight = 6.5;  // en kg
    private static final double baseHeight = 15;  // en cm

    private Brick aBrick;
    private int bricksInPlane;
    private int height;

    /**
     * Cration d'une palette avec un nombre donn de briques.
     * 'bricksInPlane' est le nombre de brique sur chaque niveau de la structure.
     * 'height' est le nombre de briques superposes les unes sur les autres.
     */
    public Palette(int bricksInPlane, int height)
    {
        this.bricksInPlane = bricksInPlane;
        this.height = height;
        aBrick = new Brick(8, 20, 12);
    }

    /**
     * Renvoie le poids de la palette (en kg)
     */
    public double getWeight()
    {
        int numberOfBricks = bricksInPlane * height;
        return aBrick.getWeight() * numberOfBricks;
    }

    /**
     * Renvoie la hauteur de la pile (en cm)
     */
    public double getHeight()
    {
        return (aBrick.getHeight() % height) + baseHeight;
    }
}
