/**
 * La partie principale du calculateur ralisant
 * la logique arithmtique des calculs.
 * @author Hacker T. Largebrain 
 * @version 0.1
 */
public class CalcEngine
{
    // La valeur de l'affichage.
    private int displayValue;
    // L'oprateur saisi prcdemment (+ ou -).
    private char previousOperator;
    // L'oprande gauche de previousOperator.
    private int leftOperand;

    /**
     * Cration d'une instance de CalcEngine.
     */
    public CalcEngine()
    {
        displayValue = 0;
        previousOperator = ' ';
        leftOperand = 0;
    }

    /**
     * @return La valeur actuellement affiche
     * par le calculateur.
     */
    public int getDisplayValue()
    {
        return displayValue;
    }

    /**
     * un bouton associ  un chiffre est appuy.
     * @param number The single digit.
     */
    public void numberPressed(int number)
    {
        displayValue = displayValue * 10 + number;
    }

    /**
     * Appele quand l'oprateur plus est appuy.
     */
    public void plus()
    {
        applyPreviousOperator();
        previousOperator = '+';
        displayValue = 0;
    }

    /**
     * Appele quand loprateur moins est appuy.
     */
    public void minus()
    {
        applyPreviousOperator();
        previousOperator = '-';
        displayValue = 0;
    }
    
    /**
     * Appele pour terminer un calcul.
     */
    public void equals()
    {
        if(previousOperator == '+') {
            displayValue = leftOperand + displayValue;
        }
        else {
            displayValue = leftOperand - displayValue;
        }
        leftOperand = 0;
    }

    /**
     * Appele pour rinitialiser la calculatrice.
     */
    public void clear()
    {
        displayValue = 0;
    }

    /**
     * @return Le titre du moteur de calcul.
     */
    public String getTitle()
    {
        return "Super Calculator";
    }

    /**
     * @return L'auteur de ce moteur.
     */
    public String getAuthor()
    {
        return "Hacker T. Largebrain";
    }

    /**
     * @return Le numro de version de ce moteur.
     */
    public String getVersion()
    {
        return "version 0.2";
    }
    
    /**
     * Un bouton associ  un oprateur a t appuy.
     * Appliquer immdiatement l'oprateur prcdent pour 
     * calculer un rsultat intermdiaire. Ce rsultat sera
     * l'oprande gauche du nouvel oprateur.
     */
    private void applyPreviousOperator()
    {
        if(previousOperator == '+') {
            leftOperand += displayValue;
        }
        else if(previousOperator == '-') {
            leftOperand -= displayValue;
        }
        else {
            // Il n'y a avait pas d'oprateur prcdent.
            leftOperand = displayValue;
        }
    }
}
