/**
 * Ralise les test de la classe Day qui implique
 * la prise de rendez-vous dune heure.
 * 
 * @author David J. Barnes et Michael Kolling
 * @version 2001.09.14
 */
public class OneHourTests
{
    // The Day object being tested.
    private Day day;

    /**
     * Constructeur pour les objets de la classe OneHourTests
     */
    public OneHourTests()
    {
        // Cr un objet Day qui peu tre utilis 
        // pour les tests.
        // Les mthodes peuvent choisir de crer 
 	   // leurs propres instances.
        day = new Day(1);
    }

    /**
     * Test de la fonctionnalit lmentaire en rservant 
     * en dbut, milieu et fin de journe.
     */
    public void makeThreeAppointments()
    {
        // Cration d'un nouvel objet Day.
        day = new Day(1);
        // Cration de trois rendez-vous d'une heure.
        Appointment first = new Appointment("Cours de Java", 1);
        Appointment second = new Appointment("TD de Java", 1);
        Appointment third = new Appointment("Rencontrer John", 1);
        
        // Prendre chaque rendez-vous  des 
        // heures diffrentes.
        day.makeAppointment(9, first);
        day.makeAppointment(13, second);
        day.makeAppointment(17, third);
        
        day.showAppointments();
    }
    
    /**
     * Vrifie que la double rservation n'est pas permise.
     */
    public void testDoubleBooking()
    {
        // Initialisation de la journe avec trois 
        // rendez-vous lgitimes.
        makeThreeAppointments();
        Appointment badAppointment = new Appointment("Error", 1);
        day.makeAppointment(9, badAppointment);
        
        // Montre que le rendez-vous badAppointment 
        // n'a pas t pris.
        day.showAppointments();
    }

    /**
     * Vrifie la fonctionnalit lmentaire en 
     * remplissant compltement une journe de rendez-vous.
     */
    public void fillTheDay()
    {
        // Cration d'un nouvel objet Day.
        day = new Day(1);
        for(int time = Day.START_OF_DAY;
                    time <= Day.FINAL_APPOINTMENT_TIME;
                        time++) {
            day.makeAppointment(time,
                                new Appointment("Test " + time, 1));
        }
        
        day.showAppointments();
    }
}
