/*
 * Class Room - une pice dans un jeu d'aventures.
 *
 * Cette classe est la classe principale de l'application "le monde de Zuul".
 * "le monde de Zuul" est un jeu d'aventures trs simple en mode texte.
 *
 * Une pice ("Room") reprsente un lieu dans le scnario du jeu.
 * Elle est relie  d'autres pices  l'aide de sorties. Les sorties
 * sont nommes nord, est, sud, ouest. Pour chaque direction, la pice stocke une rfrence
 * vers la pice voisine ou null s'il n'existe pas de sortie dans cette direction.
 * 
 * @author  Michael Kolling and David J. Barnes
 * @version 1.0 (February 2002)
 */

class Room 
{
    public String description;
    public Room northExit;
    public Room southExit;
    public Room eastExit;
    public Room westExit;

 /**
     * Cre une pice dcrite par la chane 'description'.
     * Au dpart, il n'existe aucune sortie. 
     * "description" est une chane comme "une cuisine" ou
     * "une cour de jardin".
     */
    public Room(String description) 
    {
        this.description = description;
    }

    /**
     * Dfinit les sorties de cette pice.
     * Chaque direction soit conduit  une autre pice, 
     * soit est 'null' (il n'y a pas de sortie dans cette direction).
     */
    public void setExits(Room north, Room east, Room south, Room west) 
    {
        if(north != null)
            northExit = north;
        if(east != null)
            eastExit = east;
        if(south != null)
            southExit = south;
        if(west != null)
            westExit = west;
    }

    /**
     * Renvoie la description de la pice
     * (telle que dfinie par le constructeur).
     */
    public String getDescription()
    {
        return description;
    }
}
