import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/*
 * Cette classe est la classe principale de l'application "le monde de Zuul".
 * "le monde de Zuul" est un jeu d'aventures trs simple en mode texte.
 * 
 * Cet analyseur lit les entres de l'utilisateur et essaie de l'interprter
 * comme une commande du jeu. A chaque fois qu'il est appel, l'analyseur lit
 * une ligne en utilisant le terminal et essaie de l'interpter comme une 
 * commande de deux mots. L'analyseur renvoie la commande comme un objet de 
 * de type commande.
 *
 * L'analyseur possde un ensemble de mots connus pour les commandes. Il 
 * vrifie les saisies de l'utilisateur  l'aide des commandes connues
 * et si une entre n'est pas reconnue comme une commande, il renvoie
 * un objet de type command qui est marque comme une commande inconnue
 * 
 * @author  Michael Kolling and David J. Barnes
 * @version 1.0 (February 2002)
 */

class Parser 
{

    private CommandWords commands;  // stocke toutes les commandes valides

    public Parser() 
    {
        commands = new CommandWords();
    }

    public Command getCommand() 
    {
        String inputLine = "";   // conservera la ligne d'entre dans sa totalit
        String word1;
        String word2;

        System.out.print("> ");     // affiche l'invite

        BufferedReader reader = 
            new BufferedReader(new InputStreamReader(System.in));
        try {
            inputLine = reader.readLine();
        }
        catch(java.io.IOException exc) {
            System.out.println ("Il y a eu une erreur en cours de lecture :"
                                + exc.getMessage());
        }

        StringTokenizer tokenizer = new StringTokenizer(inputLine);

        if(tokenizer.hasMoreTokens())
            word1 = tokenizer.nextToken();      // rcupration du premier mot
        else
            word1 = null;
        if(tokenizer.hasMoreTokens())
            word2 = tokenizer.nextToken();      // rcupration du deuxime mot
        else
            word2 = null;

        //  noter : nous ignorons simplement la fin de la ligne

        // Nous vrifions maintenant si le mot est connu. Si c'est le cas, nous
        // crons un objet de type command. Dans le cas contraire, nous crons 
        // une commande "null".

        if(commands.isCommand(word1))
            return new Command(word1, word2);
        else
            return new Command(null, word2);
    }

    /**
     * Affiche la liste des commandes valides
     */
    public void showCommands()
    {
        commands.showAll();
    }
}
