/**
 * La classe CD reprsente un objet CD. Les informations concernant le 
 * CD sont stockes et peuvent tre rcupres.
 * 
 * @author Michael Kolling et David J. Barnes
 * @version 2002-05-02
 */
public class CD
{
    private String title;
    private String artist;
    private int numberOfTracks;
    private int playingTime;
    private boolean gotIt;
    private String comment;

    /**
     * Initialise le CD.
     */
    public CD(String theTitle, String theArtist, int tracks, int time)
    {
        title = theTitle;
        artist = theArtist;
        numberOfTracks = tracks;
        playingTime = time;
        gotIt = false;
        comment = "pas de commentaire";
    }

    /**
     * Entre un commentaire pour ce CD.
     */
    public void setComment(String comment)
    {
        this.comment = comment;
    }

    /**
     * Retourne le commentaire de ce CD.
     */
    public String getComment()
    {
        return comment;
    }

    /**
     * Dfinit lindicateur prcisant si nous disposons de ce CD.
     */
    public void setOwn(boolean ownIt)
    {
        gotIt = ownIt;
    }

    /**
     * Retourne linformation indiquant si nous possdons une copie de ce CD.
     */
    public boolean getOwn()
    {
        return gotIt;
    }

    /**
     * Affiche les dtails concernant ce CD sur le terminal.
     */
    public void print()
    {
        System.out.print("CD: " + title + " (" + playingTime + " mn)");
        if(gotIt) {
            System.out.println("*");
        } else {
            System.out.println();
        }
        System.out.println("    " + artist);
        System.out.println("    pistes: " + numberOfTracks);
        System.out.println("    " + comment);
    }
}
