import java.util.ArrayList;
import java.util.Iterator;

/**
 * La classe Database permet de stocker des objets CD et vido. 
 * Une liste de tous les CD et vidos peut tre affiche sur le 
 * terminal.
 * 
 * Cette version nenregistre pas les donnes sur disque,
 * et ne fournit aucune fonction de recherche.
 * 
 * @author Michael Kolling et David J. Barnes
 * @version 2002-05-02
 */
public class Database
{
    private ArrayList cds;
    private ArrayList videos;

    /**
     * Construit une base de donnes vide.
     */
    public Database()
    {
        cds = new ArrayList();
        videos = new ArrayList();
    }

    /**
     * Ajoute un CD  la base de donnes.
     */
    public void addCD(CD theCD)
    {
        cds.add(theCD);
    }

    /**
     * Ajoute une vido  la base de donnes.
     */
    public void addVideo(Video theVideo)
    {
        videos.add(theVideo);
    }

    /**
     * Affiche une liste de tous les CD et vidos actuellement 
     * stocks sur le terminal.
     */
    public void list()
    {
        // affiche une liste de CD
        for(Iterator iter = cds.iterator(); iter.hasNext(); ) {
            CD cd = (CD)iter.next();
            cd.print();
            System.out.println();   // ligne vide entre des lments
        }

        // affiche une liste de vidos
        for(Iterator iter = videos.iterator(); iter.hasNext(); ) {
            Video video = (Video)iter.next();
            video.print();
            System.out.println();   // ligne vide entre des lments
        }
    }
}
