/**
 * La classe Video reprsente un objet vido. Les informations concernant la  
 * vido sont stockes et peuvent tre rcupres.
 * 
 * @author Michael Kolling et David J. Barnes
 * @version 2002-05-02
 */
public class Video 
{
    private String title;
    private String director;
    private int playingTime;
    private boolean gotIt;
    private String comment;

    /**
     * Constructeur des objets de la classe Video
     */
    public Video(String theTitle, String theDirector, int time)
    {
        title = theTitle;
        director = theDirector;
        playingTime = time;
        gotIt = false;
        comment = "pas de commentaire";
    }

    /**
     * Entre un commentaire pour cette vido.
     */
    public void setComment(String comment)
    {
        this.comment = comment;
    }

    /**
     * Retourne le commentaire de cette vido.
     */
    public String getComment()
    {
        return comment;
    }

    /**
     * Dfinit lindicateur prcisant si nous disposons de cette vido.
     */
    public void setOwn(boolean ownIt)
    {
        gotIt = ownIt;
    }

    /**
     * Retourne linformation indiquant si nous possdons une copie de cette video.
     */
    public boolean getOwn()
    {
        return gotIt;
    }

    /**
     * Affiche les dtails concernant cette vido sur le terminal.
     */
    public void print()
    {
        System.out.print("vido: " + title + " (" + playingTime + " mn)");
        if(gotIt) {
            System.out.println("*");
        } else {
            System.out.println();
        }
        System.out.println("    " + director);
        System.out.println("    " + comment);
    }
}
