import java.util.ArrayList;
import java.util.Iterator;

/**
 * La classe Database permet de stocker des objets CD et vido. 
 * Une liste de tous les CD et vidos peut tre affiche sur le 
 * terminal.
 * 
 * Cette version nenregistre pas les donnes sur disque, 
 * et ne fournit aucune fonction de recherche.
 * 
 * @author Michael Kolling et David J. Barnes
 * @version 2002-05-04
 */
public class Database
{
    private ArrayList items;

    /**
     * Construit une base de donnes vide.
     */
    public Database()
    {
        items = new ArrayList();
    }

    /**
     * Ajoute un lment  la base de donnes.
     */
    public void addItem(Item theItem)
    {
        items.add(theItem);
    }

    /**
     * Affiche une liste de tous les CD et vidos actuellement
     * stocks sur le terminal.
     */
    public void list()
    {
        for(Iterator iter = items.iterator(); iter.hasNext(); )
        {
            Item item = (Item)iter.next();
            item.print();
        }
    }
}
