/**
 * La classe Item reprsente un lment multimdia.
 * Les informations concernant cet lment sont stockes et peuvent tre rcupres.
 * Cette classe sert de superclasse pour des lments plus spcifiques.
 * 
 * @author Michael Kolling et David J. Barnes
 * @version 2002-05-04
 */
public class Item
{
    private String title;
    private int playingTime;
    private boolean gotIt;
    private String comment;

    /**
     * Initialise les champs de l'lment.
     */
    public Item(String theTitle, int time)
    {
        title = theTitle;
        playingTime = time;
        gotIt = false;
        comment = "";
    }

    /**
     * Entre un commentaire pour cet lment.
     */
    public void setComment(String comment)
    {
        this.comment = comment;
    }

    /**
     * Retourne le commentaire de cet lment.
     */
    public String getComment()
    {
        return comment;
    }

    /**
     * Dfinit l'indicateur prcisant si nous possdons cet lment.
     */
    public void setOwn(boolean ownIt)
    {
        gotIt = ownIt;
    }

    /**
     * Retourne l'information indiquant si nous possdons une copie de cet lment.
     */
    public boolean getOwn()
    {
        return gotIt;
    }

    /**
     * Affiche les dtails concernant l'lment sur le terminal.
     */
    public void print()
    {
        System.out.print("titre: " + title + " (" + playingTime + " mn)");
        if(gotIt) {
            System.out.println("*");
        } else {
            System.out.println();
        }
        System.out.println("    " + comment);
    }
}
