/**
 * Reprsente une position dans une grille rectangulaire.
 * 
 * @author David J. Barnes and Michael Kolling
 * @version 2002-04-09
 */
public class Location
{
    // Ligne (Row) et colonne (column) de la position
    private int row;
    private int col;

    /**
     * Reprsente une ligne et une colonne.
     * @param row Ligne
     * @param col Colonne
     */
    public Location(int row, int col)
    {
        this.row = row;
        this.col = col;
    }
    
    /**
     * Implante l'galit de contenu.
     */
    public boolean equals(Object obj)
    {
        if(obj instanceof Location) {
            Location other = (Location) obj;
            return row == other.getRow() && col == other.getCol();
        }
        else {
            return false;
        }
    }
    
    /**
     * Renvoie une chane ligne,colonne
     * @return Une reprsentation chane de la position
     */
    public String toString()
    {
        return row + "," + col;
    }
    
    /**
     * Utilise les 16 bits forts pour la valeur de la ligne et les 16 bits faibles
     * pour la colonne. Fournit une cl de hachage unique pour chaque paire
     * (ligne,colonne) sauf pour de trs grandes grilles.
     */
    public int hashCode()
    {
        return (row << 16) + col;
    }
    
    /**
     * @return The row.
     */
    public int getRow()
    {
        return row;
    }
    
    /**
     * @return The column.
     */
    public int getCol()
    {
        return col;
    }
}
