import java.util.List;

/**
 * Animal est une classe abstraite pour les animaux. Elle fournit
 * les lments communs  tous les animaux (ge, position, etc.).
 * 
 * @author David J. Barnes and Michael Kolling
 * @version 2002-04-11
 */
public abstract class Animal
{
    // L'ge de l'animal.
    private int age;
    // Vivant ou non
    private boolean alive;
    // La position de l'animal
    private Location location;

    /**
     * Cr un nouvel animal d'ge zro (nouveau n).
     */
    public Animal()
    {
        age = 0;
        alive = true;
    }
    
    /**
     * Fait agir l'animal - fait ce qu'il veut ou doit
     * faire.
     */
    abstract public void act(Field currentField, 
                             Field updatedField, List newAnimals);
    
    /**
     * Teste si l'animal est vivant ou non.
     * @return True si l'animal est vivant.
     */
    public boolean isAlive()
    {
        return alive;
    }

    /**
     * Signale  l'animal qu'il est mort :(
     */
    public void setDead()
    {
        alive = false;
    }
    
    /**
     * Renvoie l'ge de l'animal
     * @return l'ge de l'animal
     */
    public int getAge()
    {
        return age;
    }

    /**
     * Dfinit l'ge de l'animal.
     * @param age L'ge de l'animal.
     */
    public void setAge(int age)
    {
        this.age = age;
    }
    
    /**
     * Renvoie la position de l'animal.
     * @return La position de l'animal.
     */
    public Location getLocation()
    {
        return location;
    }

    /**
     * Dfinit la position de l'animal.
     * @param row Coordonne verticale (ligne) de la position
     * @param col Coordonne horizontale (colonne) de la position
     */
    public void setLocation(int row, int col)
    {
        this.location = new Location(row, col);
    }

    /**
     * Dfinit la position de l'animal.
     * @param location La position de l'animal.
     */
    public void setLocation(Location location)
    {
        this.location = location;
    }
}
