/**
 * Une interface en mode texte pour la classe AddressBook.
 * Plusieurs commandes donnent accs aux donnes du carnet d'adresses.
 *
 *      une pour la recherche dans le carnet d'adresses.
 *
 *      une pour entrer les coordonnes d'un contact.
 *
 *      une pour visualiser toutes les entres du carnet.
 *
 * @author David J. Barnes and Michael Kolling.
 * @version 2002.06.11
 */
public class AddressBookTextInterface
{
    // Le carnet d'adresses  visualiser et manipuler.
    private AddressBook book;
    // Un analyseur pour grer les commandes utilisateur.
    private Parser parser;
    
    /**
     * Constructeur d'objets de la classe AddressBookTextInterface
     * @param book Le carnet d'adresses  grer.
     */
    public AddressBookTextInterface(AddressBook book)
    {
        this.book = book;
        parser = new Parser();
    }
    
    /**
     * Lit une commande utilisateur pour interagir avec le carnet d'adresses.
     * Termine quand l'utilisateur entre 'quitter'.
     */
    public void run()
    {
        System.out.println("Carnet d'adresses.");
        System.out.println("Entrez 'aide' pour la liste des commandes.");
        
        String command;
        do{
            command = parser.getCommand();
            if(command.equals("ajouter")){ 
                add();
            }
            else if(command.equals("lister")){
                list();
            }
            else if(command.equals("chercher")){
                find();
            }
            else if(command.equals("aide")){
                help();
            }
            else{
                // Ne rien faire.
            }
        } while(!(command.equals("quitter")));

        System.out.println("Au revoir.");
    }
    
    /**
     * Ajoute une entre.
     */
    private void add()
    {
        System.out.print("Nom: ");
        String name = parser.readLine();
        System.out.print("Tlphone: ");
        String phone = parser.readLine();
        System.out.print("Adresse: ");
        String address = parser.readLine();
        book.addDetails(new ContactDetails(name, phone, address));
    }
    
    /**
     * Trouver les entres de prfixe donn.
     */
    private void find()
    {
        System.out.println("Entrez un prfixe de la cl  trouver.");
        String prefix = parser.readLine();
        ContactDetails[] results = book.search(prefix);
        for(int i = 0; i < results.length; i++){
            System.out.println(results[i]);
            System.out.println("=====");
        }
    }
    
    /**
     * Liste les commandes disponibles.
     */
    private void help()
    {
        parser.showCommands();
    }
    
    /**
     * Liste le contenu du carnet d'adresses.
     */
    private void list()
    {
        System.out.println(book.listDetails());
    }
}
