/**
 * Une dmonstration lmentaire d'utilisation de la classe AddressBook.
 * Quelques donnes sont places dans le carnet d'adresses 
 * et on visualise le carnet dans un terminal fentr.
 * 
 * @author David J. Barnes and Michael Kolling.
 * @version 2002.05.08
 */
public class AddressBookDemo
{
    private AddressBook book;
    private AddressBookTextInterface interaction;

    /**
     * Construire un carnet d'adresses avec quelques donnes.
     * Le carnet d'adresses est transmis  une interface graphique
     * pour visualisation.
     */
    public AddressBookDemo()
    {
        ContactDetails[] sampleDetails = {
            new ContactDetails("david",     "03 26 91 32 16", "addresse 1"),
            new ContactDetails("michal",   "03 26 91 33 67", "addresse 2"),
            new ContactDetails("jean",      "03 26 32 21 33", "addresse 3"),
            new ContactDetails("hlne",    "03 26 71 56 45", "addresse 4"),
            new ContactDetails("emma",      "03 26 12 38 91", "addresse 5"),
            new ContactDetails("catherine", "03 26 93 72 18", "addresse 6"),
            new ContactDetails("christian", "03 26 02 81 45", "addresse 7"),
            new ContactDetails("ruth",      "03 26 98 71 31", "addresse 8"),
        };
        book = new AddressBook();
        for(int i = 0; i < sampleDetails.length; i++) {
            book.addDetails(sampleDetails[i]);
        }
        interaction = new AddressBookTextInterface(book);
    }
    
    /**
     * Permet  l'utilisateur d'interagir avec le carnet d'adresses.
     */
    public void showInterface()
    {
        interaction.run();
    }

    /**
     * @return Le carnet d'adresses avec ses donnes.
     */
    public AddressBook getBook()
    {
        return book;
    }
}
