import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.util.StringTokenizer;

/*
 * Une classe qui lit des lignes entres par l'utilisateur.
 * Les entres sont vrifies par getCommand.
 *
 * @author  Michael Kolling and David J. Barnes
 * @version 2002.06.11
 */

public class Parser 
{
    // Contient tous les mots cls des commandes.
    private CommandWords commands;

    public Parser() 
    {
        commands = new CommandWords();
    }

    /**
     * Lit une commande fournie par l'utilisateur.
     * La commande retourne est toujours une commande valide.
     * @return Une commande valide.
     */
    public String getCommand() 
    {
        String command = null;
        do {
            String word1;
            // Afficher une invite.
            System.out.print("> ");
            
            String inputLine = readLine();
            // Scinder la ligne pour extraire le premier mot.
            StringTokenizer tokenizer = new StringTokenizer(inputLine);    
            if(tokenizer.hasMoreTokens()) {
                word1 = tokenizer.nextToken();
                if(commands.isCommand(word1)) {
                    command = word1;
                }
                else{
                    System.out.println("Commande inconnue: " + word1);
                    System.out.print("Commandes disponibles: ");
                    commands.showAll();
                }
            }
        } while(command == null);
    
        return command;
    }
    
    /**
     * Essaie de lire une ligne unique fournie par l'utilisateur.
     * Renvoie une ligne vide si erreur.
     * @return La ligne.
     */
    public String readLine()
    {
        try {
            BufferedReader reader = 
                new BufferedReader(new InputStreamReader(System.in));
            return reader.readLine();
        }
        catch(IOException exc) {
            System.out.println ("Une erreur s'est produite pendant la lecture: "
                                + exc.getMessage());
            return "";
        }
    }

    /**
     * Affiche la liste des commandes valides.
     */
    public void showCommands()
    {
        commands.showAll();
    }
}
