/**
 * Capture une cl sans entre
 * dans le carnet d'adresses.
 * 
 * @author David J. Barnes and Michael Kolling.
 * @version 2002.05.14
 */
public class NoMatchingDetailsException extends Exception
{
    // La cl sans entre.
    private String key;

    /**
     * Stocke la cl.
     * @param key La cl sans entre.
     */
    public NoMatchingDetailsException(String key)
    {
        this.key = key;
    }

    /**
     * @return La cl qui a provoqu l'erreur.
     */
    public String getKey()
    {
        return key;
    }
    
    /**
     * @return Une chane de diagnostic contenant la cl provoquant l'erreur.
     */
    public String toString()
    {
        return "Pas de coordonnes trouves correspondant : " + key + ".";
    }
}
