import java.awt.Image;
import javax.swing.ImageIcon;

/**
 * Modlise un passager aller d'un endroit
 *  un autre.
 * 
 * @author David J. Barnes and Michael Kolling
 * @version 2002.06.20
 */
public class Passenger implements DrawableItem
{
    private Location pickup;
    private Location destination;
    private Image image;

    /**
     * Constructeur pour les objets de la classe Passenger
     * @param pickup Le lieu de chargement, doit tre non 'null'.
     * @param destination Le lieu de destination, doit tre non 'null'.
     * @throws NullPointerException Si un lieu est 'null'.
     */
    public Passenger(Location pickup, Location destination)
    {
        if(pickup == null) {
            throw new NullPointerException("Point de chargement");
        }
        if(destination == null) {
            throw new NullPointerException("Lieu de destination");
        }
        this.pickup = pickup;
        this.destination = destination;
        // Charge l'image utilise pour reprsenter une personne.
        image = new ImageIcon(getClass().getResource(
                              "images/person.jpg")).getImage();
    }
    
    /**
     * @return Une reprsentation chane de cette personne.
     */
    public String toString()
    {
        return "Passager en transit de " +
               pickup + " vers " + destination;
    }

    /**
     * @return L'image  afficher dans un environnement graphique.
     */
    public Image getImage()
    {
        return image;
    }
    
    /**
     * @return La position de prise en charge du passager.
     */
    public Location getLocation()
    {
        return pickup;
    }

    /**
     * @return La position de prise en charge.
     */
    public Location getPickupLocation()
    {
        return pickup;
    }
    
    /**
     * @return Le lieu de destination.
     */
    public Location getDestination()
    {
        return destination;
    }
}
