import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * Lance la simulation en demandant  une collection d'acteurs d'agir.
 * 
 * @author David J. Barnes and Michael Kolling
 * @version 2002.07.02
 */
public class Simulation
{
    private List actors;
    private int step;

    /**
     * Cr l'ensemble initial d'acteurs pour la simulation.
     */
    public Simulation()
    {
        actors = new LinkedList();
        step = 0;
        City city = new City();
        TaxiCompany company = new TaxiCompany(city);
        PassengerSource source = new PassengerSource(city, company);
        
        actors.addAll(company.getVehicles());
        actors.add(source);
        actors.add(new CityGUI(city));
    }
    
    /**
     * Excute la simulation pour un nombre fixe de pas.
     * Fait une pause aprs chaque pas pour permettre la mise  jour de l'environnement graphique.
     */
    public void run()
    {
        for(int i = 0; i < 500; i++){
            step++;
            step();
            wait(100);
        }
    }

    /**
     * Ralise un pas de simulation.
     */
    public void step()
    {
        Iterator it = actors.iterator();
        while(it.hasNext()) {
            Actor actor = (Actor) it.next();
            actor.act();
        }
    }
    
    /**
     * Attend un nombre donn de millisecondes avant de finir.
     * Ceci permet de gnrer un court dlai.
     * @param milliseconds Le nombre de millisecondes  attendre.
     */
    private void wait(int milliseconds)
    {
        try
        {
            Thread.sleep(milliseconds);
        } 
        catch (InterruptedException e)
        {
            // ignorer l'exception
        }
    }
}
