/**
 * Simule des passagers qui demandent un taxi d'une compagnie.
 * Les passagers doivent tre gnrs  des intervalles alatoires.
 * 
 * @author David J. Barnes and Michael Kolling
 * @version 2002.06.20
 */
public class PassengerSource
{
    private TaxiCompany company;

    /**
     * Constructeur d'objets de la classe PassengerSource.
     * @param company La compagnie  utiliser. Doit tre non 'null'.
     * @throws NullPointerException si la compagnie est 'null'.
     */
    public PassengerSource(TaxiCompany company)
    {
        if(company == null) {
            throw new NullPointerException("compagnie");
        }
        this.company = company;
    }

    /**
     * La source gnre un nouveau passager et
     * demande une prise en charge  la compagnie.
     * @return true Si la demande russit, false sinon.
     */
    public boolean requestPickup()
    {
        Passenger passenger = createPassenger();
        return company.requestPickup(passenger);
    }

    /**
     * Cre un nouveau passager.
     * @return Le passager cr.
     */
    private Passenger createPassenger()
    {
        return new Passenger(new Location(), new Location());
    }
}
