import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

/**
 * Modlise le fonctionnement d'une compagnie de taxis 
 * avec diffrents vhicules.
 * 
 * @author David J. Barnes and Michael Kolling
 * @version 2002.06.20
 */
public class TaxiCompany  
{
    private List vehicles;

    /**
     * Constructeur pour les objets de la classe TaxiCompany
     */
    public TaxiCompany()
    {
        vehicles = new LinkedList();
    }

    /**
     * Demande une prise en charge pour le passager donn.
     * @param passenger Le passager demandant une course.
     * @return Si oui ou non un vhicule est libre.
     */
    public boolean requestPickup(Passenger passenger)
    {
        Vehicle vehicle = scheduleVehicle();
        if(vehicle != null) {
            vehicle.setPickupLocation(passenger.getPickupLocation());
            return true;
        }
        else {
            return false;
        }
    }
    
    /**
     * Un vhicule est arriv au lieu de prise en charge.
     * @param Le vhicule au point de chargement.
     */
    public void arrivedAtPickup(Vehicle vehicle)
    {
    }
    
    /**
     * Un vhicule est arriv  destination.
     * @param Le vhicule  destination.
     * @param Le passager dbarqu.
     */
    public void arrivedAtDestination(Vehicle vehicle,
                                     Passenger passenger)
    {
    }
    
    /**
     * Trouve un vhicule libre si possible.
     * @return Un vhicule libre, 'null' s'il n'y en a pas.
     */
    private Vehicle scheduleVehicle()
    {
        Iterator it = vehicles.iterator();
        while(it.hasNext()) {
            Vehicle vehicle = (Vehicle) it.next();
            if(vehicle.isFree()) {
                return vehicle;
            }
        }
        return null;
    }
}
