
/**
 * Indique qu'il n'y avait pas de passager au lieu de prise en charge.
 * 
 * @author David J. Barnes and Michael Kolling
 * @version 2002.07.02
 */
public class MissingPassengerException extends RuntimeException
{
    private Vehicle vehicle;
    /**
     * Constructeur pour les objets de la classe MissingPassengerException.
     * @param vehicle Le vhicule attendant un passager.
     */
    public MissingPassengerException(Vehicle vehicle)
    {
        super("Passager absent au lieu de prise en charge.");
    }

    /**
     * @return Le vhicule pour lequel il n'y a pas de passager.
     */
    public Vehicle getVehicle()
    {
        return vehicle;
    }
}
