/**
 * Modlise un passager aller d'un endroit
 *  un autre.
 * 
 * @author David J. Barnes and Michael Kolling
 * @version 2002.06.20
 */
public class Passenger
{
    private Location pickup;
    private Location destination;

    /**
     * Constructeur pour les objets de la classe Passenger
     * @param pickup Le lieu de chargement, doit tre non 'null'.
     * @param destination Le lieu de destination, doit tre non 'null'.
     * @throws NullPointerException Si un lieu est 'null'.
     */
    public Passenger(Location pickup, Location destination)
    {
        if(pickup == null) {
            throw new NullPointerException("Point de chargement");
        }
        if(destination == null) {
            throw new NullPointerException("Lieu de destination");
        }
        this.pickup = pickup;
        this.destination = destination;
    }
    
    public String toString()
    {
        return "Passager en transit de " +
               pickup + " vers " + destination;
    }

    /**
     * @return La position de prise en charge.
     */
    public Location getPickupLocation()
    {
        return pickup;
    }
    
    /**
     * @return Le lieu de destination.
     */
    public Location getDestination()
    {
        return destination;
    }
}
