import java.util.List;
import java.util.LinkedList;
    
/**
 * Une navette (shuttle) peut transporter plusieurs passagers.
 * 
 * @author David J. Barnes and Michael Kolling
 * @version 2002.06.20
 */
public class Shuttle extends Vehicle
{
    // La liste des destinations de la navette.
    private List destinations;
    // La liste des passagers de la navette.
    private List passengers;

    /**
     * Constructeur pour les objets de la classe Shuttle.
     * @param company La compagnie de taxis. Doit tre non 'null'.
     * @param location Le point de dpart du vhicule. Doit tre non 'null'.
     * @throws NullPointerException Si la compagnie ou la position est 'null'.
     */
    public Shuttle(TaxiCompany company, Location location)
    {
        super(company, location);
        destinations = new LinkedList();
        passengers = new LinkedList();
    }

    /**
     * Excute les actions d'une navette.
     */
    public void act()
    {
    }

    /**
     * @return si oui ou non ce vhicule est libre.
     */
    public boolean isFree()
    {
        return true;
    }
    
    /**
     * Reoit une position de prise en charge.
     * @location La position de prise en charge.
     */
    public void setPickupLocation(Location location)
    {
        destinations.add(location);
        chooseTargetLocation();
    }
    
    /**
     * Reoit un passager.
     * Ajoute sa destination  la liste.
     * @param passenger Le passager.
     */
    public void pickup(Passenger passenger)
    {
        passengers.add(passenger);
        destinations.add(passenger.getDestination());
        chooseTargetLocation();
    }

    /**
     * Dcide o aller maintenant, en utilisant la liste des
     * destinations possibles.
     */
    private void chooseTargetLocation()
    {
    }

    /**
     * Dcharge un passager dont la destination est
     * la position courante.
     */
    public void offloadPassenger()
    {
    }
}
